#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#define MSG 1

int main(int argc, char *argv[])
{
  int vet[5],i;
  int size, rank, len;
  char hostname[MPI_MAX_PROCESSOR_NAME];
  MPI_Status st;
  
  MPI_Init(&argc, &argv);
  
  // determinar a quantidade de processos
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  // determinar a identificacao de cada processo
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  // pego o nome da maquina
  MPI_Get_processor_name(hostname,&len);
  
  if (rank == 0)
  {
      for(i=0;i<5;i++)
         vet[i] = i+1;
      
      
      //envios individuais
      for (i=1;i<size;i++)
      {
         printf("MESTRE-Enviando para %d\n",i); fflush(stdout);
         MPI_Send(vet,5,MPI_INT,i,MSG,MPI_COMM_WORLD);
      }   
  }
  else
  {
      MPI_Recv(vet,5,MPI_INT,0,MSG,MPI_COMM_WORLD,&st);
      printf("ESC %d - Emissor:%d - Mensagem %d\n",rank,st.MPI_SOURCE,st.MPI_TAG);
      fflush(stdout);
  }
  
  MPI_Finalize();  

  return 0;
}
