#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define SIZE 1000

int main(int argc, char *argv[])
{
  int *vetor;
  int vet[SIZE];
  int rank,size,i;
  char arq[10];
  FILE *f;
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  printf("Processo %d de %d\n",rank,size); fflush(stdout);
  
  if (rank ==0)
  {
     vetor = (int*) malloc (sizeof(int)*size*SIZE);
     for(i=0;i<size*SIZE;i++)
        vetor[i] = i+1;
  }
  MPI_Scatter(vetor, SIZE, MPI_INT, vet, SIZE, MPI_INT, 0, MPI_COMM_WORLD);
  strcpy(arq,"arq00.txt");
  arq[4] = rank + 48;
  f = fopen(arq,"wt+");
  for (i=0;i<SIZE;i++) fprintf(f, "%d ",vet[i]);
  fclose(f);
  MPI_Finalize();
  return 0;
}
